# Algoritmo para calcular la convolución
# (si la ventana no es simétrica se está calculando
#  la correlación cruzada, y esto nos da que tanto
#  se parace la señal de entrada a la señal de la 
#  ventana)
# 
# Entrada: Un archivo con la señal de entrada, de largo n
#          La señal de la ventana, de largo m
# Salida : La señal convolucionada, donde no puede calcular
#          se pondrán ceros, para mantener la señal de
#          salida en fase con la señal de entrada.
# 
#    x[] la señal de entrada de tamaño n,
#    v[] la señal de la ventana de tamaño m

import numpy as np
import sys

n = len( sys.argv )
if n != 3 :
	print( "Args: archivo_señal archivo_ventana" )
	sys.exit(1)

vx = np.loadtxt( sys.argv[1] )
n, = vx.shape
vv = np.loadtxt( sys.argv[2] )
m, = vv.shape

if n < m :
	print( "El tamaño de la señal de entrada debe ser mayor que la ventana" )
	sys.exit(2)

vven = np.zeros( (n,) )
i = 0
while i < m :
	vven[i-2] = vv[m-i-1]
	i += 1
# Se invirtió la señal de la venta para que el resultado
# sea la correlación cruzada, si no se invierte da como
# resultado la correlación.

VX = np.fft.rfft( vx )
VV = np.fft.rfft( vven )

R = VX * VV

vr = np.fft.irfft( R )
n, = vr.shape

i = 0
while i<n :
	print( vr[i] )
	i += 1

